--
-- Teleskopladerser
--
-- M@D Author  StarT  gswlad
-- M@D date  15.3.2012

Teleskopladerser = {}

function Teleskopladerser.prerequisitesPresent(specializations)
    Vehicle.registerJointType("Frontloader");
	return true ;
end;

function Teleskopladerser:load(xmlFile)

	self.mirrors = {};
    self.mirrors3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.mirrors.mirror3#index"));
    self.mirrors4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.mirrors.mirror4#index"));
    self.mirrors6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.mirrors.mirror6#index"));
	self.mirrors7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.mirrors.mirror7#index"));
    self.mirrors8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.mirrors.mirror8#index"));
	self.bcL = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bLight#index"));
	self.fcL = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fLight#index"));
	self.drawMirror = false;
	self.drawMirror3 = false;
	self.toggleWindowState = SpecializationUtil.callSpecializationsFunction("toggleWindowState");
	self.toggleDoorState = SpecializationUtil.callSpecializationsFunction("toggleDoorState");

--[[panel]]------------------------------------------------------------
	self.numkablights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kablights#count"), 0);
    self.kablights = {};
    for i=1, self.numkablights do
        local kablightsnamei = string.format("vehicle.kablights.kablights" .. "%d", i);
        self.kablights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, kablightsnamei .. "#index"));
        setVisibility(self.kablights[i], false);
    end;	
    self.kablightsActive = false;
	self.tankwarn = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.tankwarn#time"), 30000);
	tankback = self.tankwarn;

local rotationPartNodekorobka0 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka0#index"));
    if rotationPartNodekorobka0 ~= nil then
        self.rotationPartkorobka0 = {};
        self.rotationPartkorobka0.node = rotationPartNodekorobka0;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka0#minRot"));
        self.rotationPartkorobka0.minRot = {};
        self.rotationPartkorobka0.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka0.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka0.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka0#maxRot"));
        self.rotationPartkorobka0.maxRot = {};
        self.rotationPartkorobka0.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka0.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka0.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka0.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka0#rotTime"), 2)*1000;
        self.rotationPartkorobka0.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka0#touchRotLimit"), 10));
    end;
 local rotationPartNodekorobka = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka#index"));
    if rotationPartNodekorobka ~= nil then
        self.rotationPartkorobka = {};
        self.rotationPartkorobka.node = rotationPartNodekorobka;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka#minRot"));
        self.rotationPartkorobka.minRot = {};
        self.rotationPartkorobka.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka#maxRot"));
        self.rotationPartkorobka.maxRot = {};
        self.rotationPartkorobka.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka#rotTime"), 2)*1000;
        self.rotationPartkorobka.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka#touchRotLimit"), 10));
    end;

local rotationPartNodekorobka1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka1#index"));
    if rotationPartNodekorobka1 ~= nil then
        self.rotationPartkorobka1 = {};
        self.rotationPartkorobka1.node = rotationPartNodekorobka1;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka1#minRot"));
        self.rotationPartkorobka1.minRot = {};
        self.rotationPartkorobka1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka1#maxRot"));
        self.rotationPartkorobka1.maxRot = {};
        self.rotationPartkorobka1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka1#rotTime"), 2)*1000;
        self.rotationPartkorobka1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka1#touchRotLimit"), 10));
    end;

local rotationPartNodekorobka2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka2#index"));
    if rotationPartNodekorobka2 ~= nil then
        self.rotationPartkorobka2 = {};
        self.rotationPartkorobka2.node = rotationPartNodekorobka2;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka2#minRot"));
        self.rotationPartkorobka2.minRot = {};
        self.rotationPartkorobka2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka2#maxRot"));
        self.rotationPartkorobka2.maxRot = {};
        self.rotationPartkorobka2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka2#rotTime"), 2)*1000;
        self.rotationPartkorobka2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka2#touchRotLimit"), 10));
    end;	

local rotationPartNodekorobka3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka3#index"));
    if rotationPartNodekorobka3 ~= nil then
        self.rotationPartkorobka3 = {};
        self.rotationPartkorobka3.node = rotationPartNodekorobka3;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka3#minRot"));
        self.rotationPartkorobka3.minRot = {};
        self.rotationPartkorobka3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka3#maxRot"));
        self.rotationPartkorobka3.maxRot = {};
        self.rotationPartkorobka3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka3#rotTime"), 2)*1000;
        self.rotationPartkorobka3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka3#touchRotLimit"), 10));
    end;		

local rotationPartNodekorobka4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobka4#index"));
    if rotationPartNodekorobka4 ~= nil then
        self.rotationPartkorobka4 = {};
        self.rotationPartkorobka4.node = rotationPartNodekorobka4;

	local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobka4#minRot"));
        self.rotationPartkorobka4.minRot = {};
        self.rotationPartkorobka4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobka4#maxRot"));
        self.rotationPartkorobka4.maxRot = {};
        self.rotationPartkorobka4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobka4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobka4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobka4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka4#rotTime"), 2)*1000;
        self.rotationPartkorobka4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobka4#touchRotLimit"), 10));
    end;

local rotationPartNodekorobkazad = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.korobkazad#index"));
    if rotationPartNodekorobkazad ~= nil then
        self.rotationPartkorobkazad = {};
        self.rotationPartkorobkazad.node = rotationPartNodekorobkazad;

	local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkorobkazad#minRot"));
        self.rotationPartkorobkazad.minRot = {};
        self.rotationPartkorobkazad.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobkazad.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobkazad.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.korobkazad#maxRot"));
        self.rotationPartkorobkazad.maxRot = {};
        self.rotationPartkorobkazad.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkorobkazad.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkorobkazad.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkorobkazad.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobkazad#rotTime"), 2)*1000;
        self.rotationPartkorobkazad.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.korobkazad#touchRotLimit"), 10));
    end;

    self.wiper1Active = false;	
    self.wiper2Active = false;
    self.wiper3Active = false;	
    self.wiper4Active = false;
    self.wiper5Active = false;	
    self.wiper6Active = false;	
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayWischer1 = 0;
    self.delayWischer2 = 0;
    self.delayOn = 0;
    self.delayOff = 0;
    self.deltafo = 0;

local wiper1Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper1#index"));
    if wiper1Node ~= nil then
        self.wiper1 = {};
        self.wiper1.node = wiper1Node;
    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper1#minRot"));
        self.wiper1.minRot = {};
        self.wiper1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper1#maxRot"));
        self.wiper1.maxRot = {};
        self.wiper1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper1#rotTime"), 2)*1000;
        self.wiper1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper1#touchRotLimit"), 10));
    end;
	
local wiper2Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper2#index"));
    if wiper2Node ~= nil then
        self.wiper2 = {};
        self.wiper2.node = wiper2Node;
    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper2#minRot"));
        self.wiper2.minRot = {};
        self.wiper2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper2#maxRot"));
        self.wiper2.maxRot = {};
        self.wiper2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper2#rotTime"), 2)*1000;
        self.wiper2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper2#touchRotLimit"), 10));
    end;


local wiper3Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper3#index"));
    if wiper3Node ~= nil then
        self.wiper3 = {};
        self.wiper3.node = wiper3Node;
    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper3#minRot"));
        self.wiper3.minRot = {};
        self.wiper3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper3#maxRot"));
        self.wiper3.maxRot = {};
        self.wiper3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper3#rotTime"), 2)*1000;
        self.wiper3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper3#touchRotLimit"), 10));
    end;
	
local wiper4Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper4#index"));
    if wiper4Node ~= nil then
        self.wiper4 = {};
        self.wiper4.node = wiper4Node;
    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper4#minRot"));
        self.wiper4.minRot = {};
        self.wiper4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper4#maxRot"));
        self.wiper4.maxRot = {};
        self.wiper4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper4#rotTime"), 2)*1000;
        self.wiper4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper4#touchRotLimit"), 10));
    end;

local wiper5Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper5#index"));
    if wiper5Node ~= nil then
        self.wiper5 = {};
        self.wiper5.node = wiper5Node;
    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper5#minRot"));
        self.wiper5.minRot = {};
        self.wiper5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper5#maxRot"));
        self.wiper5.maxRot = {};
        self.wiper5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper5#rotTime"), 2)*1000;
        self.wiper5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper5#touchRotLimit"), 10));
    end;
	
local wiper6Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper6#index"));
    if wiper6Node ~= nil then
        self.wiper6 = {};
        self.wiper6.node = wiper6Node;
	local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper6#minRot"));
        self.wiper6.minRot = {};
        self.wiper6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper6#maxRot"));
        self.wiper6.maxRot = {};
        self.wiper6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper6#rotTime"), 2)*1000;
        self.wiper6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper6#touchRotLimit"), 10));
    end;


local rotationPartNodepoworotnika = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.poworotnika#index"));
    if rotationPartNodepoworotnika ~= nil then
        self.rotationPartpoworotnika = {};
        self.rotationPartpoworotnika.node = rotationPartNodepoworotnika;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpoworotnika#minRot"));
        self.rotationPartpoworotnika.minRot = {};
        self.rotationPartpoworotnika.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnika.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnika.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.poworotnika#maxRot"));
        self.rotationPartpoworotnika.maxRot = {};
        self.rotationPartpoworotnika.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnika.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnika.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpoworotnika.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnika#rotTime"), 2)*1000;
        self.rotationPartpoworotnika.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnika#touchRotLimit"), 10));
    end;

local rotationPartNodepoworotnikk = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.poworotnikk#index"));
    if rotationPartNodepoworotnikk ~= nil then
        self.rotationPartpoworotnikk = {};
        self.rotationPartpoworotnikk.node = rotationPartNodepoworotnikk;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpoworotnikk#minRot"));
        self.rotationPartpoworotnikk.minRot = {};
        self.rotationPartpoworotnikk.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnikk.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnikk.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.poworotnikk#maxRot"));
        self.rotationPartpoworotnikk.maxRot = {};
        self.rotationPartpoworotnikk.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnikk.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnikk.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpoworotnikk.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnikk#rotTime"), 2)*1000;
        self.rotationPartpoworotnikk.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnikk#touchRotLimit"), 10));
    end;

local rotationPartNodepoworotnik = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.poworotnik#index"));
    if rotationPartNodepoworotnik ~= nil then
        self.rotationPartpoworotnik = {};
        self.rotationPartpoworotnik.node = rotationPartNodepoworotnik;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpoworotnik#minRot"));
        self.rotationPartpoworotnik.minRot = {};
        self.rotationPartpoworotnik.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnik.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnik.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.poworotnik#maxRot"));
        self.rotationPartpoworotnik.maxRot = {};
        self.rotationPartpoworotnik.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnik.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnik.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpoworotnik.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnik#rotTime"), 2)*1000;
        self.rotationPartpoworotnik.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnik#touchRotLimit"), 10));
    end;

local rotationPartNodepoworotnik0 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.poworotnik0#index"));
    if rotationPartNodepoworotnik0 ~= nil then
        self.rotationPartpoworotnik0 = {};
        self.rotationPartpoworotnik0.node = rotationPartNodepoworotnik0;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpoworotnik0#minRot"));
        self.rotationPartpoworotnik0.minRot = {};
        self.rotationPartpoworotnik0.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnik0.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnik0.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.poworotnik0#maxRot"));
        self.rotationPartpoworotnik0.maxRot = {};
        self.rotationPartpoworotnik0.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpoworotnik0.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpoworotnik0.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpoworotnik0.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnik0#rotTime"), 2)*1000;
        self.rotationPartpoworotnik0.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.poworotnik0#touchRotLimit"), 10));
    end;

local rotationPartNodePedal3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartPedal3#index"));
    if rotationPartNodePedal3 ~= nil then
        self.rotationPartPedal3 = {};
        self.rotationPartPedal3.node = rotationPartNodePedal3;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal3#minRot"));
        self.rotationPartPedal3.minRot = {};
        self.rotationPartPedal3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal3#maxRot"));
        self.rotationPartPedal3.maxRot = {};
        self.rotationPartPedal3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPedal3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal3#rotTime"), 2)*1000;
        self.rotationPartPedal3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal3#touchRotLimit"), 10));
    end;

local rotationPartNodePedal2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartPedal2#index"));
    if rotationPartNodePedal2 ~= nil then
        self.rotationPartPedal2 = {};
        self.rotationPartPedal2.node = rotationPartNodePedal2;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal2#minRot"));
        self.rotationPartPedal2.minRot = {};
        self.rotationPartPedal2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal2#maxRot"));
        self.rotationPartPedal2.maxRot = {};
        self.rotationPartPedal2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPedal2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal2#rotTime"), 2)*1000;
        self.rotationPartPedal2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal2#touchRotLimit"), 10));
    end;

local rotationPartNodeDrehzahl1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#index"));
    if rotationPartNodeDrehzahl1 ~= nil then
        self.rotationPartDrehzahl1 = {};
        self.rotationPartDrehzahl1.node = rotationPartNodeDrehzahl1;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#minRot"));
        self.rotationPartDrehzahl1.minRot = {};
        self.rotationPartDrehzahl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#maxRot"));
        self.rotationPartDrehzahl1.maxRot = {};
        self.rotationPartDrehzahl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDrehzahl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#rotTime"), 2)*1000;
        self.rotationPartDrehzahl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#touchRotLimit"), 10));
    end;
	
local rotationPartNodeDrehzahl2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#index"));
    if rotationPartNodeDrehzahl2 ~= nil then
        self.rotationPartDrehzahl2 = {};
        self.rotationPartDrehzahl2.node = rotationPartNodeDrehzahl2;

	local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#minRot"));
        self.rotationPartDrehzahl2.minRot = {};
        self.rotationPartDrehzahl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#maxRot"));
        self.rotationPartDrehzahl2.maxRot = {};
        self.rotationPartDrehzahl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDrehzahl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#rotTime"), 2)*1000;
        self.rotationPartDrehzahl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#touchRotLimit"), 10));
    end;

      self.tanklight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tanklight#index"));

      self.tanklightActive = false;

local rotationPartNodeTanknadel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartTanknadel#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.rotationPartTanknadel = {};
        self.rotationPartTanknadel.node = rotationPartNodeTanknadel;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#minRot"));
        self.rotationPartTanknadel.minRot = {};
        self.rotationPartTanknadel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#maxRot"));
        self.rotationPartTanknadel.maxRot = {};
        self.rotationPartTanknadel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartTanknadel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#rotTime"), 2)*1000;
        self.rotationPartTanknadel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#touchRotLimit"), 10));
    end;
	
local rotationPartNodeOil = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartOil#index"));
    if rotationPartNodeOil ~= nil then
        self.rotationPartOil = {};
        self.rotationPartOil.node = rotationPartNodeOil;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartOil#minRot"));
        self.rotationPartOil.minRot = {};
        self.rotationPartOil.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartOil.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartOil.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartOil#maxRot"));
        self.rotationPartOil.maxRot = {};
        self.rotationPartOil.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartOil.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartOil.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartOil.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartOil#rotTime"), 2)*1000;
        self.rotationPartOil.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartOil#touchRotLimit"), 10));
    end;

    fuelwarningSoundFile = Utils.getFilename("sounds/fuelwarning.ogg", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;

local rotationPartNodePedal = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartPedal#index"));
    if rotationPartNodePedal ~= nil then
        self.rotationPartPedal = {};
        self.rotationPartPedal.node = rotationPartNodePedal;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal#minRot"));
        self.rotationPartPedal.minRot = {};
        self.rotationPartPedal.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal#maxRot"));
        self.rotationPartPedal.maxRot = {};
        self.rotationPartPedal.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPedal.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal#rotTime"), 2)*1000;
        self.rotationPartPedal.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal#touchRotLimit"), 10));
    end;

local rotationPartNodeKmh1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartKmh1#index"));
    if rotationPartNodeKmh1 ~= nil then
        self.rotationPartKmh1 = {};
        self.rotationPartKmh1.node = rotationPartNodeKmh1;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#minRot"));
        self.rotationPartKmh1.minRot = {};
        self.rotationPartKmh1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#maxRot"));
        self.rotationPartKmh1.maxRot = {};
        self.rotationPartKmh1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartKmh1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#rotTime"), 2)*1000;
        self.rotationPartKmh1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#touchRotLimit"), 10));
    end;

local rotationPartNodeBrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartBrake#index"));
    if rotationPartNodeBrake ~= nil then
        self.rotationPartBrake = {};
        self.rotationPartBrake.node = rotationPartNodeBrake;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#minRot"));
        self.rotationPartBrake.minRot = {};
        self.rotationPartBrake.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#maxRot"));
        self.rotationPartBrake.maxRot = {};
        self.rotationPartBrake.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartBrake.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#rotTime"), 2)*1000;
        self.rotationPartBrake.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#touchRotLimit"), 10));
    end;

end;

      
function Teleskopladerser:delete()    
end;


function Teleskopladerser:mouseEvent(posX, posY, isDown, isUp, button)
end;

	  
function Teleskopladerser:keyEvent(unicode, sym, modifier, isDown)
end;

function Teleskopladerser:update(dt)
-- input loop
	if self.isEntered then
		if InputBinding.hasEvent(InputBinding.Cab_Light) then 
			self.drawMirror3 = not self.drawMirror3;
			setVisibility(self.mirrors3, self.drawMirror3);
		end;
		if InputBinding.hasEvent(InputBinding.Mirrors) then 
			self.drawMirror = not self.drawMirror;
		end;
		if InputBinding.hasEvent(InputBinding.Enter_Exit) and (self.camIndex == 2) then 
			self:toggleDoorState();
		end;
		if InputBinding.hasEvent(InputBinding.Window) then
			self:toggleWindowState();
		end;
		if Input.isKeyPressed(Input.KEY_KP_enter) then
			self.rotationMaxPedal3 = true;
		else
			self.rotationMaxPedal3 = false;
		end;
		if Input.isKeyPressed(Input.KEY_KP_multiply) then
			self.rotationMaxPedal2 = true;
		else
			self.rotationMaxPedal2 = false;
		end;
		if Input.isKeyPressed(Input.KEY_KP_minus) then
			self.rotationMaxPedal = true;
		else
			self.rotationMaxPedal = false;
		end;
		if Input.isKeyPressed(Input.KEY_KP_divide) then
			self.rotationMaxBrake = true;
		else
			self.rotationMaxBrake = false;
		end;
		if Input.isKeyPressed(Input.KEY_w) and self.isMotorStarted then
			setVisibility(self.fcL,true);
		else
			setVisibility(self.fcL,false);
		end;
		if InputBinding.hasEvent(InputBinding.Wiper) then
			self.wiper1Active = not self.wiper1Active;
			self.wiper2Active = not self.wiper2Active;
			self.wiper3Active = not self.wiper3Active;
			self.wiper4Active = not self.wiper4Active;
			self.wiper5Active = not self.wiper5Active;
			self.wiper6Active = not self.wiper6Active;
		 end;

--[[info]]------------------------------------------------------------
				--toggle displaying HUD
		if InputBinding.hasEvent(InputBinding.TOGGLEHUD) then
			if self.helpPanel then
				self.helpPanel = false;
			else
				self.helpPanel = true;
			end;
		end;
	end;

--[[Fuel Guage]]------------------------------------------------------------

		if self.rotationPartTanknadel ~= nil then
			local x, y, z = getRotation(self.rotationPartTanknadel.node);
			y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
			setRotation(self.rotationPartTanknadel.node, x, y ,z);
		end;

	setVisibility(self.mirrors4, self.drawMirror);
    setVisibility(self.mirrors6, self.drawMirror);
	setVisibility(self.mirrors7, not self.drawMirror);
    setVisibility(self.mirrors8, not self.drawMirror);
	
	if self.isEntered then
		if self.isMotorStarted then
			self.kablightsActive = true;
		else
			self.kablightsActive = false;
		end;
		for i=1, self.numkablights do
			local kablights = self.kablights[i];
			setVisibility(kablights, self.kablightsActive);
		end;
	end;
--[[rul]]------------------------------------------------------------
	setVisibility(self.bcL, self.B3.bla)
	;
	if self.motor.lastMotorRpm > 300 and self.motor.lastMotorRpm < 650 then
		self.rotationMaxkorobka = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 650 and self.motor.lastMotorRpm < 700 then
		self.rotationMaxkorobka = false;
		self.rotationMaxkorobka1 = false;
		self.rotationMaxkorobka0 = true;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 700 and self.motor.lastMotorRpm < 1050 then
		self.rotationMaxkorobka1 = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 1050 and self.motor.lastMotorRpm < 1100 then
		self.rotationMaxkorobka1 = false;
		self.rotationMaxkorobka2 = false;
		self.rotationMaxkorobka0 = true;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 1100 and self.motor.lastMotorRpm < 1550 then
		self.rotationMaxkorobka2 = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 1550 and self.motor.lastMotorRpm < 1600 then
		self.rotationMaxkorobka2 = false;
		self.rotationMaxkorobka3 = false;
		self.rotationMaxkorobka0 = true;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 1600 and self.motor.lastMotorRpm < 1950 then
		self.rotationMaxkorobka3 = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 1950 and self.motor.lastMotorRpm < 2000 then
		self.rotationMaxkorobka3 = false;
		self.rotationMaxkorobka4 = false;
		self.rotationMaxkorobka0 = true;
		self.rotationMaxkorobkazad = false;
	elseif self.motor.lastMotorRpm > 2000 then
		self.rotationMaxkorobka4 = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobkazad = false;
	end;	
	if self.brakeSoundAllow then
		self.rotationMaxkorobkazad = true;
		self.rotationMaxkorobka0 = false;
		self.rotationMaxkorobka = false;
		self.rotationMaxkorobka1 = false;
		self.rotationMaxkorobka2 = false;
		self.rotationMaxkorobka3 = false;
		self.rotationMaxkorobka4 = false;
	end;		
	
	if self.motor.lastMotorRpm < 300 then
		self.rotationMaxkorobka0 = true;
		self.rotationMaxkorobka = false;
		self.rotationMaxkorobka1 = false;
		self.rotationMaxkorobka2 = false;
		self.rotationMaxkorobka3 = false;
		self.rotationMaxkorobka4 = false;
		self.rotationMaxkorobkazad = false;
	end;

	if self.rotationMaxkorobka0 == true then
		if self.rotationPartkorobka0 ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka0.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka0.maxRot, self.rotationPartkorobka0.minRot, 3, self.rotationPartkorobka0.rotTime, dt, not self.rotationMaxkorobka0);
		   setRotation(self.rotationPartkorobka0.node, unpack(newRot));
       end;
	end;

	if self.rotationMaxkorobka == true then
		if self.rotationPartkorobka ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka.maxRot, self.rotationPartkorobka.minRot, 3, self.rotationPartkorobka.rotTime, dt, not self.rotationMaxkorobka);
		   setRotation(self.rotationPartkorobka.node, unpack(newRot));
       end;
	end;
	
	if self.rotationMaxkorobka1 == true then	   
		if self.rotationPartkorobka1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka1.maxRot, self.rotationPartkorobka1.minRot, 3, self.rotationPartkorobka1.rotTime, dt, not self.rotationMaxkorobka1);
		   setRotation(self.rotationPartkorobka1.node, unpack(newRot));
       end;
	end;
	
	if self.rotationMaxkorobka2 == true then
		if self.rotationPartkorobka2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka2.maxRot, self.rotationPartkorobka2.minRot, 3, self.rotationPartkorobka2.rotTime, dt, not self.rotationMaxkorobka2);
		   setRotation(self.rotationPartkorobka2.node, unpack(newRot));
       end;
	end;
 
	if self.rotationMaxkorobka3 == true then
		if self.rotationPartkorobka3 ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka3.maxRot, self.rotationPartkorobka3.minRot, 3, self.rotationPartkorobka3.rotTime, dt, not self.rotationMaxkorobka3);
		   setRotation(self.rotationPartkorobka3.node, unpack(newRot));
       end;
	end;

	if self.rotationMaxkorobka4 == true then
		if self.rotationPartkorobka4 ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobka4.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobka4.maxRot, self.rotationPartkorobka4.minRot, 3, self.rotationPartkorobka4.rotTime, dt, not self.rotationMaxkorobka4);
		   setRotation(self.rotationPartkorobka4.node, unpack(newRot));
       end;
	end;

	if self.rotationMaxkorobkazad == true then
		if self.rotationPartkorobkazad ~= nil then
		   local x, y, z = getRotation(self.rotationPartkorobkazad.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkorobkazad.maxRot, self.rotationPartkorobkazad.minRot, 3, self.rotationPartkorobkazad.rotTime, dt, not self.rotationMaxkorobkazad);
		   setRotation(self.rotationPartkorobkazad.node, unpack(newRot));
		end;
	end;

	if self.isEntered then
		if self.fuelFillLevel <= 50 then
			self.tankwarn = self.tankwarn - dt;
				if self.tankwarn <= 0 then
					playSample(self.fuelwarningSoundId,1,1,0);
					self.tankwarn = tankback;
				end;
			self.tanklightActive = true;
		else
			self.tankwarn = tankback;
			self.tanklightActive = false;
		end;
			setVisibility(self.tanklight,self.tanklightActive);
	end;

	if self.rotationPartTanknadel ~= nil then
		local x, y, z = getRotation(self.rotationPartTanknadel.node);
		y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
		setRotation(self.rotationPartTanknadel.node, x, y ,z);
	end;

	local maxDrehzahl = self.motor.maxRpm;
	local rampRpm = 42.3728813559322;
	self.facRPM = math.max(self.lastSpeed * 3600 * rampRpm, 300);

    if not self.isMotorStarted then
		self.facRPM = 0
	end;
	
	if self.rotationPartDrehzahl1 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl1.node);
		y = ((self.rotationPartDrehzahl1.maxRot[2] - self.rotationPartDrehzahl1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl1.minRot[2];
		setRotation(self.rotationPartDrehzahl1.node, x, y ,z);
	end;

	if self.rotationPartDrehzahl2 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl2.node);
		y = ((self.rotationPartDrehzahl2.maxRot[2] - self.rotationPartDrehzahl2.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl2.minRot[2];
		setRotation(self.rotationPartDrehzahl2.node, x, y ,z);
	end;
	
	if self.rotationPartOil ~= nil then
		local x, y, z = getRotation(self.rotationPartOil.node);
		y = ((self.rotationPartOil.maxRot[2] - self.rotationPartOil.minRot[2]) / maxDrehzahl) * self.facRPM + self.rotationPartOil.minRot[2];
		setRotation(self.rotationPartOil.node, x, y ,z);
	end;



local maxKmh = 59;

	if self.rotationPartKmh1 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh1.node);
		y = ((self.rotationPartKmh1.maxRot[2] - self.rotationPartKmh1.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh1.minRot[2];
		setRotation(self.rotationPartKmh1.node, x, y ,z);
	end;
	
	if self.rotationPartKmh2 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh2.node);
		y = ((self.rotationPartKmh2.maxRot[2] - self.rotationPartKmh2.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh2.minRot[2];
		setRotation(self.rotationPartKmh2.node, x, y ,z);
	end;
	if self.isMotorStarted then
		if self.wiper1Active or g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if self.delayWischer1 >= 0 then
				self.delayWischer1 = self.delayWischer1 -dt;
			end;
			if self.delayWischer2 >= 0 then
				self.delayWischer2 = self.delayWischer2 -dt;
			end;
			if not self.wiper1Max then
			   if self.delayWischer1 < 0 then
					self.delayWischer2 = 1000;
					self.wiper1Max = true;
					self.wiper2Max = true;
					self.wiper3Max = true;
					self.wiper4Max = true;
					self.wiper5Max = true;
					self.wiper6Max = true;
				end;
			end;
			if self.wiper1Max then
				if self.delayWischer2 < 0 then
					self.delayWischer1 = 1000;
					self.wiper1Max = false;
					self.wiper2Max = false;
					self.wiper3Max = false;
					self.wiper4Max = false;
					self.wiper5Max = false;
					self.wiper6Max = false;
				end;
			end;
		else
			self.wiper1Max = false;
			self.wiper2Max = false;
			self.wiper3Max = false;
			self.wiper4Max = false;
			self.wiper5Max = false;
			self.wiper6Max = false;
		end;
	end;

    if self.wiper1 ~= nil then
       	local x, y, z = getRotation(self.wiper1.node);
       	local rot = {x,y,z};
       	local newRot = Utils.getMovedLimitedValues(rot, self.wiper1.maxRot, self.wiper1.minRot, 3, self.wiper1.rotTime, dt, not self.wiper1Max);
       	setRotation(self.wiper1.node, unpack(newRot));
    end;
		
	if self.wiper2 ~= nil then
       	local x, y, z = getRotation(self.wiper2.node);
       	local rot = {x,y,z};
       	local newRot = Utils.getMovedLimitedValues(rot, self.wiper2.maxRot, self.wiper2.minRot, 3, self.wiper2.rotTime, dt, not self.wiper2Max);
       	setRotation(self.wiper2.node, unpack(newRot));
    end;
	
	if self.wiper3 ~= nil then
       	local x, y, z = getRotation(self.wiper3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.wiper3.maxRot, self.wiper3.minRot, 3, self.wiper3.rotTime, dt, not self.wiper3Max);
        setRotation(self.wiper3.node, unpack(newRot));
    end;
		
	if self.wiper4 ~= nil then
       	local x, y, z = getRotation(self.wiper4.node);
       	local rot = {x,y,z};
       	local newRot = Utils.getMovedLimitedValues(rot, self.wiper4.maxRot, self.wiper4.minRot, 3, self.wiper4.rotTime, dt, not self.wiper4Max);
       	setRotation(self.wiper4.node, unpack(newRot));
    end;
	
	if self.wiper5 ~= nil then
       	local x, y, z = getRotation(self.wiper5.node);
       	local rot = {x,y,z};
       	local newRot = Utils.getMovedLimitedValues(rot, self.wiper5.maxRot, self.wiper5.minRot, 3, self.wiper5.rotTime, dt, not self.wiper5Max);
       	setRotation(self.wiper5.node, unpack(newRot));
    end;
		
	if self.wiper6 ~= nil then
       	local x, y, z = getRotation(self.wiper6.node);
       	local rot = {x,y,z};
       	local newRot = Utils.getMovedLimitedValues(rot, self.wiper6.maxRot, self.wiper6.minRot, 3, self.wiper6.rotTime, dt, not self.wiper6Max);
       	setRotation(self.wiper6.node, unpack(newRot));
    end;
	
	self.rotationMaxpoworotnik = self.B3.dirLeft[1].a and not self.B3.dirRight[1].a;
	self.rotationMaxpoworotnikk = self.B3.dirRight[1].a and not self.B3.dirLeft[1].a;
	self.rotationMaxpoworotnika = self.B3.dirRight[1].a and self.B3.dirLeft[1].a;
	self.rotationMaxpoworotnik0 =  not self.rotationMaxpoworotnik and not self.rotationMaxpoworotnikk and not self.rotationMaxpoworotnika;
	
	if self.rotationMaxpoworotnik0 then -- center
		if self.rotationPartpoworotnik0 ~= nil then
			local x, y, z = getRotation(self.rotationPartpoworotnik0.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpoworotnik0.maxRot, self.rotationPartpoworotnik0.minRot, 3, self.rotationPartpoworotnik0.rotTime, dt, not self.rotationMaxpoworotnik0);
			setRotation(self.rotationPartpoworotnik0.node, unpack(newRot));
		end;
	end;
	
	if self.rotationMaxpoworotnika then --flashers
		if self.rotationPartpoworotnika ~= nil then
		   local x, y, z = getRotation(self.rotationPartpoworotnika.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpoworotnika.maxRot, self.rotationPartpoworotnika.minRot, 3, self.rotationPartpoworotnika.rotTime, dt, not self.rotationMaxpoworotnika);
		   setRotation(self.rotationPartpoworotnika.node, unpack(newRot));
		end;
	end;
	
	if self.rotationMaxpoworotnikk then  --right
		if self.rotationPartpoworotnikk ~= nil then
			local x, y, z = getRotation(self.rotationPartpoworotnikk.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpoworotnikk.maxRot, self.rotationPartpoworotnikk.minRot, 3, self.rotationPartpoworotnikk.rotTime, dt, not self.rotationMaxpoworotnikk);
			setRotation(self.rotationPartpoworotnikk.node, unpack(newRot));
		end;
	end;
	
	if self.rotationMaxpoworotnik then --left
		if self.rotationPartpoworotnik ~= nil then
			local x, y, z = getRotation(self.rotationPartpoworotnik.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpoworotnik.maxRot, self.rotationPartpoworotnik.minRot, 3, self.rotationPartpoworotnik.rotTime, dt, not self.rotationMaxpoworotnik);
			setRotation(self.rotationPartpoworotnik.node, unpack(newRot));
       end;
	end;

	if self.rotationPartPedal3 ~= nil then
		local x, y, z = getRotation(self.rotationPartPedal3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPedal3.maxRot, self.rotationPartPedal3.minRot, 3, self.rotationPartPedal3.rotTime, dt, not self.rotationMaxPedal3);
		setRotation(self.rotationPartPedal3.node, unpack(newRot));
	end;

	if self.rotationPartPedal2 ~= nil then
		local x, y, z = getRotation(self.rotationPartPedal2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPedal2.maxRot, self.rotationPartPedal2.minRot, 3, self.rotationPartPedal2.rotTime, dt, not self.rotationMaxPedal2);
		setRotation(self.rotationPartPedal2.node, unpack(newRot));
	end;

	if self.rotationPartPedal ~= nil then
		local x, y, z = getRotation(self.rotationPartPedal.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPedal.maxRot, self.rotationPartPedal.minRot, 3, self.rotationPartPedal.rotTime, dt, not self.rotationMaxPedal);
		setRotation(self.rotationPartPedal.node, unpack(newRot));
	end;

     if self.rotationPartBrake ~= nil then
		local x, y, z = getRotation(self.rotationPartBrake.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartBrake.maxRot, self.rotationPartBrake.minRot, 3, self.rotationPartBrake.rotTime, dt, not self.rotationMaxBrake);
		setRotation(self.rotationPartBrake.node, unpack(newRot));
	end;
	
end;

function Teleskopladerser:toggleWindowState()
	if self.animationParts[2].clipEndTime then
		self:setAnimationTime(2, self.animationParts[2].startPosition);
	else
		self:setAnimationTime(2, self.animationParts[2].animDuration);
	end;
end;

function Teleskopladerser:toggleDoorState()
	if self.animationParts[1].clipEndTime then
		self:setAnimationTime(1, self.animationParts[1].startPosition);
	else
		self:setAnimationTime(1, self.animationParts[1].animDuration);
	end;
end;

function Teleskopladerser:draw()

--[[info]]------------------------------------------------------------
	
	if self.isEntered then
		if self.helpPanel then
			g_currentMission:addHelpButtonText(g_i18n:getText("725_Hide_Hud"),InputBinding.TOGGLEHUD);
			g_currentMission:addHelpButtonText(g_i18n:getText("Sunvisor"),InputBinding.Sunvisor);
			g_currentMission:addHelpButtonText(g_i18n:getText("Window"),InputBinding.Window);
			g_currentMission:addHelpButtonText(g_i18n:getText("SideSeat"),InputBinding.SideSeat);
			g_currentMission:addHelpButtonText(g_i18n:getText("Steering_Col"),InputBinding.Steering_Col);
			g_currentMission:addHelpButtonText(g_i18n:getText("Cab_Light"),InputBinding.Cab_Light);
			if (self.camIndex == 2) then
				g_currentMission:addHelpButtonText(g_i18n:getText("Enter_Exit"),InputBinding.Enter_Exit);
			end;
			g_currentMission:addHelpButtonText(g_i18n:getText("HandBrake"),InputBinding.HandBrake);
			g_currentMission:addHelpButtonText(g_i18n:getText("Mirrors"),InputBinding.Mirrors);
			if self.isMotorStarted then
				g_currentMission:addHelpButtonText(g_i18n:getText("Wiper"),InputBinding.Wiper);
			end;
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("725_Show_Hud"),InputBinding.TOGGLEHUD);
		end;
	end;
end;

function Teleskopladerser:connectCollisions(varName)
	local Collision = self.collisionArm[varName];
	local constr = JointConstructor:new();
	constr:setActors(self.rootNode, Collision.collision);
	constr:setJointTransforms(Collision.armAttacher, Collision.collisionAttacher);
	for i=1, 3 do
		constr:setRotationLimit(i-1, 0, 0, 0);
		constr:setTranslationLimit(i-1, true, 0, 0);
	end;
	Collision.index = constr:finalize();
end